<?
# Convert number to bulgarian text represantation
# v0.02
#
# Copyright (c) 2003 Georgi Chorbadzhiyski, Sofia, Bulgaria
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
#  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
#  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
#  EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

/*
	     :)   bug-,    
	   , -   ,  -    /dev/null

	          :
		Email   : georgi()unixsol!org
		Web page: http://georgi.unixsol.org/
*/
	error_reporting(E_ALL);

/* The functions */
	$_num0   = array(0 => "",1 => "",2 => "",3 => "",4 => "",
	                 5 => "",6 => "",7 => "",8 => "",9 => "",
	                 10 => "", 11 => "", 12 => "");
	$_num100 = array(1 => "", 2 => "", 3 => "");

	function num2bgtext($number) {
		global $_num0, $_num100;

		$number = (int)$number;

		$_div10 = ($number - $number % 10) / 10;
		$_mod10 = $number % 10;
		$_div100 = ($number - $number % 100) / 100;
		$_mod100 = $number % 100;
		$_div1000 = ($number - $number % 1000) / 1000;
		$_mod1000 = $number % 1000;
		$_div1000000 = ($number - $number % 1000000) / 1000000;
		$_mod1000000 = $number % 1000000;
		$_div1000000000 = ($number - $number % 1000000000) / 1000000000;
		$_mod1000000000 = $number % 1000000000;

		if ($number == 0) {
			return $_num0[$number];
		}
		/*   */
		if ($number > 0 && $number < 20) {
			return isset($_num0[$number]) ? $_num0[$number] : $_num0[$_mod10]."";
		}
		/*   */
		if ($number > 19 && $number < 100) {
			$tmp = ($_div10 == 2) ? "" : $_num0[$_div10]."";
			$tmp = $_mod10 ? $tmp."  ".num2bgtext($_mod10) : $tmp;
			return $tmp;
		}
		/*   */
		if ($number > 99 && $number < 1000) {
			$tmp = isset($_num100[$_div100]) ? $_num100[$_div100] : $_num0[$_div100]."";
			if (($_mod100 % 10 == 0 || $_mod100 < 20) && $_mod100 != 0) {
				$tmp .= " ";
			}
			if ($_mod100) {
				$tmp .= " ".num2bgtext($_mod100);
			}
			return $tmp;
		}
		/*   */
		if ($number > 999 && $number < 1000000) {
			/* Damn bulgarian @#$%@#$%   is wrong :) */
			$_num0[2] = "";
			$tmp = ($_div1000 == 1) ? "" : num2bgtext($_div1000)." ";
			$_num0[2] = "";
			if (($_mod1000 % 10 == 0 || $_mod1000 < 20) && $_mod1000 != 0) {
				if (!(($_mod100 % 10 == 0 || $_mod100 < 20) && $_mod100 != 0)) {
					$tmp .= " ";
				}
			}
			if (($_mod1000 % 10 == 0 || $_mod1000 < 20) && $_mod1000 != 0 && $_mod1000 < 100) {
				$tmp .= " ";
			}
			if ($_mod1000) {
				$tmp .= " ".num2bgtext($_mod1000);
			}
			return $tmp;
		}
		/*   */
		if ($number > 999999 && $number < 1000000000) {
			$tmp = ($_div1000000 == 1) ? " " : num2bgtext($_div1000000)." ";
			if (($_mod1000000 % 10 == 0 || $_mod1000000 < 20) && $_mod1000000 != 0) {
				if (!(($_mod1000 % 10 == 0 || $_mod1000 < 20) && $_mod1000 != 0)) {
					if (!(($_mod100 % 10 == 0 || $_mod100 < 20) && $_mod100 != 0)) {
						$tmp .= " ";
					}
				}
			}
			$and = ", ";
			if (($_mod1000000 % 10 == 0 || $_mod1000000 < 20) && $_mod1000000 != 0 && $_mod1000000 < 1000) {
				if (($_mod1000 % 10 == 0 || $_mod1000 < 20) && $_mod1000 != 0 && $_mod1000 < 100) {
					$tmp .= " ";
				}
			}
			if ($_mod1000000) {
				$tmp .= " ".num2bgtext($_mod1000000);
			}
			return $tmp;
		}
		/*   */
		if ($number > 99999999 && $number <= 2000000000) {
			$tmp = ($_div1000000000 == 1) ? " " : "";
			$tmp = ($_div1000000000 == 2) ? " " : $tmp;
			if ($_mod1000000000) {
				$tmp .= " ".num2bgtext($_mod1000000000);
			}
			return $tmp;
		}
		/* Bye ... */
		return "";
	}

	function number2lv($number) {
		list($lv, $st) = split("\.", number_format($number,2,".",""));
		$lv = (int)$lv;
		if ($lv >= 2000000000)
			return "TooBigNumber";
		$text = num2bgtext($lv) . " .";
		if ($st && $st != 0) {
			$text .= "  " . num2bgtext($st) . " .";
		}
		return $text;
	}
?>